package myTools;

import josx.platform.rcx.*;
import myTools.myTools;

public class myOptic {
	
	Sensor s;
	private int value; 
	int white;
	int green;
	int black;
	int wgborder;
	int gbborder;
	int lastcolor;

	public myOptic(Sensor newS){
		s=newS;
		s.activate();
		s.setTypeAndMode(SensorConstants.SENSOR_TYPE_LIGHT,
				SensorConstants.SENSOR_MODE_PCT);
	}
	
	public boolean calibrating(String sensorlabel){
		TextLCD.print(sensorlabel);
		myTools.sleep(500);
		TextLCD.print("white");
		Sound.beep();
		while (!Button.VIEW.isPressed()) {
		}
		while (Button.VIEW.isPressed()) {
			white = s.readRawValue();
			Sound.beep();
			LCD.showNumber(white);myTools.sleep(1000);
		}
		TextLCD.print("green");
		Sound.beep();
		while (!Button.VIEW.isPressed()) {
		}
		while (Button.VIEW.isPressed()) {
			green = s.readRawValue();
			Sound.beep();
			LCD.showNumber(green);myTools.sleep(1000);
		}
		if (white>green) return false; 
		TextLCD.print("black");
		Sound.beep();
		while (!Button.VIEW.isPressed()) {
		}
		while (Button.VIEW.isPressed()) {
			black = s.readRawValue();
			Sound.beep();
			LCD.showNumber(black);myTools.sleep(1000);
		}
		if (green>black) return false; 
		wgborder = (white+green)/2;
		gbborder = (green+black)/2;
		return true;
	}
	
	private int readSensor(){
		return s.readRawValue();
	}
	
	public int getColor(){
		value = readSensor();
		if (value<wgborder) lastcolor = 3;		//return wei
		else if (value<gbborder) lastcolor = 2;	//return grn
		else lastcolor = 1;						//return schwarz
		return lastcolor;
	}
	
	public boolean isBlack(){
		return lastcolor == 1;
	}
	
	public boolean isGreen(){
		return lastcolor == 2;
	}
	
	public boolean isWhite(){
		return lastcolor == 3;
	}
	
}
